<?php

namespace ArtabanMarketplace\Model\Base;

use \DateTime;
use \Exception;
use \PDO;
use ArtabanMarketplace\Model\AmpSellerOrder as ChildAmpSellerOrder;
use ArtabanMarketplace\Model\AmpSellerOrderQuery as ChildAmpSellerOrderQuery;
use ArtabanMarketplace\Model\AmpSellerOrderVersionQuery as ChildAmpSellerOrderVersionQuery;
use ArtabanMarketplace\Model\Map\AmpSellerOrderVersionTableMap;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\ModelCriteria;
use Propel\Runtime\ActiveRecord\ActiveRecordInterface;
use Propel\Runtime\Collection\Collection;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Exception\BadMethodCallException;
use Propel\Runtime\Exception\PropelException;
use Propel\Runtime\Map\TableMap;
use Propel\Runtime\Parser\AbstractParser;
use Propel\Runtime\Util\PropelDateTime;

abstract class AmpSellerOrderVersion implements ActiveRecordInterface
{
    /**
     * TableMap class name
     */
    const TABLE_MAP = '\\ArtabanMarketplace\\Model\\Map\\AmpSellerOrderVersionTableMap';


    /**
     * attribute to determine if this object has previously been saved.
     * @var boolean
     */
    protected $new = true;

    /**
     * attribute to determine whether this object has been deleted.
     * @var boolean
     */
    protected $deleted = false;

    /**
     * The columns that have been modified in current object.
     * Tracking modified columns allows us to only update modified columns.
     * @var array
     */
    protected $modifiedColumns = array();

    /**
     * The (virtual) columns that are added at runtime
     * The formatters can add supplementary columns based on a resultset
     * @var array
     */
    protected $virtualColumns = array();

    /**
     * The value for the id field.
     * @var        int
     */
    protected $id;

    /**
     * The value for the order_id field.
     * @var        int
     */
    protected $order_id;

    /**
     * The value for the amp_seller_id field.
     * @var        int
     */
    protected $amp_seller_id;

    /**
     * The value for the customer_id field.
     * @var        int
     */
    protected $customer_id;

    /**
     * The value for the order_product_id field.
     * @var        string
     */
    protected $order_product_id;

    /**
     * The value for the amp_seller_order_counter field.
     * @var        int
     */
    protected $amp_seller_order_counter;

    /**
     * The value for the seller_order_ref field.
     * @var        string
     */
    protected $seller_order_ref;

    /**
     * The value for the discount field.
     * Note: this column has a database default value of: '0.000000'
     * @var        string
     */
    protected $discount;

    /**
     * The value for the postage field.
     * Note: this column has a database default value of: '0.000000'
     * @var        string
     */
    protected $postage;

    /**
     * The value for the postage_tax field.
     * Note: this column has a database default value of: '0.000000'
     * @var        string
     */
    protected $postage_tax;

    /**
     * The value for the status_id field.
     * @var        int
     */
    protected $status_id;

    /**
     * The value for the created_at field.
     * @var        string
     */
    protected $created_at;

    /**
     * The value for the updated_at field.
     * @var        string
     */
    protected $updated_at;

    /**
     * The value for the version field.
     * Note: this column has a database default value of: 0
     * @var        int
     */
    protected $version;

    /**
     * The value for the version_created_at field.
     * @var        string
     */
    protected $version_created_at;

    /**
     * The value for the version_created_by field.
     * @var        string
     */
    protected $version_created_by;

    /**
     * The value for the customer_id_version field.
     * Note: this column has a database default value of: 0
     * @var        int
     */
    protected $customer_id_version;

    /**
     * The value for the amp_seller_id_version field.
     * Note: this column has a database default value of: 0
     * @var        int
     */
    protected $amp_seller_id_version;

    /**
     * The value for the order_id_version field.
     * Note: this column has a database default value of: 0
     * @var        int
     */
    protected $order_id_version;

    /**
     * The value for the amp_seller_order_delivery_reference_ids field.
     * @var        array
     */
    protected $amp_seller_order_delivery_reference_ids;

    /**
     * The unserialized $amp_seller_order_delivery_reference_ids value - i.e. the persisted object.
     * This is necessary to avoid repeated calls to unserialize() at runtime.
     * @var object
     */
    protected $amp_seller_order_delivery_reference_ids_unserialized;

    /**
     * The value for the amp_seller_order_delivery_reference_versions field.
     * @var        array
     */
    protected $amp_seller_order_delivery_reference_versions;

    /**
     * The unserialized $amp_seller_order_delivery_reference_versions value - i.e. the persisted object.
     * This is necessary to avoid repeated calls to unserialize() at runtime.
     * @var object
     */
    protected $amp_seller_order_delivery_reference_versions_unserialized;

    /**
     * @var        AmpSellerOrder
     */
    protected $aAmpSellerOrder;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     *
     * @var boolean
     */
    protected $alreadyInSave = false;

    /**
     * Applies default values to this object.
     * This method should be called from the object's constructor (or
     * equivalent initialization method).
     * @see __construct()
     */
    public function applyDefaultValues()
    {
        $this->discount = '0.000000';
        $this->postage = '0.000000';
        $this->postage_tax = '0.000000';
        $this->version = 0;
        $this->customer_id_version = 0;
        $this->amp_seller_id_version = 0;
        $this->order_id_version = 0;
    }

    /**
     * Initializes internal state of ArtabanMarketplace\Model\Base\AmpSellerOrderVersion object.
     * @see applyDefaults()
     */
    public function __construct()
    {
        $this->applyDefaultValues();
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return boolean True if the object has been modified.
     */
    public function isModified()
    {
        return !!$this->modifiedColumns;
    }

    /**
     * Has specified column been modified?
     *
     * @param  string  $col column fully qualified name (TableMap::TYPE_COLNAME), e.g. Book::AUTHOR_ID
     * @return boolean True if $col has been modified.
     */
    public function isColumnModified($col)
    {
        return $this->modifiedColumns && isset($this->modifiedColumns[$col]);
    }

    /**
     * Get the columns that have been modified in this object.
     * @return array A unique list of the modified column names for this object.
     */
    public function getModifiedColumns()
    {
        return $this->modifiedColumns ? array_keys($this->modifiedColumns) : [];
    }

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return boolean true, if the object has never been persisted.
     */
    public function isNew()
    {
        return $this->new;
    }

    /**
     * Setter for the isNew attribute.  This method will be called
     * by Propel-generated children and objects.
     *
     * @param boolean $b the state of the object.
     */
    public function setNew($b)
    {
        $this->new = (Boolean) $b;
    }

    /**
     * Whether this object has been deleted.
     * @return boolean The deleted state of this object.
     */
    public function isDeleted()
    {
        return $this->deleted;
    }

    /**
     * Specify whether this object has been deleted.
     * @param  boolean $b The deleted state of this object.
     * @return void
     */
    public function setDeleted($b)
    {
        $this->deleted = (Boolean) $b;
    }

    /**
     * Sets the modified state for the object to be false.
     * @param  string $col If supplied, only the specified column is reset.
     * @return void
     */
    public function resetModified($col = null)
    {
        if (null !== $col) {
            if (isset($this->modifiedColumns[$col])) {
                unset($this->modifiedColumns[$col]);
            }
        } else {
            $this->modifiedColumns = array();
        }
    }

    /**
     * Compares this with another <code>AmpSellerOrderVersion</code> instance.  If
     * <code>obj</code> is an instance of <code>AmpSellerOrderVersion</code>, delegates to
     * <code>equals(AmpSellerOrderVersion)</code>.  Otherwise, returns <code>false</code>.
     *
     * @param  mixed   $obj The object to compare to.
     * @return boolean Whether equal to the object specified.
     */
    public function equals($obj)
    {
        $thisclazz = get_class($this);
        if (!is_object($obj) || !($obj instanceof $thisclazz)) {
            return false;
        }

        if ($this === $obj) {
            return true;
        }

        if (null === $this->getPrimaryKey()
            || null === $obj->getPrimaryKey())  {
            return false;
        }

        return $this->getPrimaryKey() === $obj->getPrimaryKey();
    }

    /**
     * If the primary key is not null, return the hashcode of the
     * primary key. Otherwise, return the hash code of the object.
     *
     * @return int Hashcode
     */
    public function hashCode()
    {
        if (null !== $this->getPrimaryKey()) {
            return crc32(serialize($this->getPrimaryKey()));
        }

        return crc32(serialize(clone $this));
    }

    /**
     * Get the associative array of the virtual columns in this object
     *
     * @return array
     */
    public function getVirtualColumns()
    {
        return $this->virtualColumns;
    }

    /**
     * Checks the existence of a virtual column in this object
     *
     * @param  string  $name The virtual column name
     * @return boolean
     */
    public function hasVirtualColumn($name)
    {
        return array_key_exists($name, $this->virtualColumns);
    }

    /**
     * Get the value of a virtual column in this object
     *
     * @param  string $name The virtual column name
     * @return mixed
     *
     * @throws PropelException
     */
    public function getVirtualColumn($name)
    {
        if (!$this->hasVirtualColumn($name)) {
            throw new PropelException(sprintf('Cannot get value of inexistent virtual column %s.', $name));
        }

        return $this->virtualColumns[$name];
    }

    /**
     * Set the value of a virtual column in this object
     *
     * @param string $name  The virtual column name
     * @param mixed  $value The value to give to the virtual column
     *
     * @return AmpSellerOrderVersion The current object, for fluid interface
     */
    public function setVirtualColumn($name, $value)
    {
        $this->virtualColumns[$name] = $value;

        return $this;
    }

    /**
     * Logs a message using Propel::log().
     *
     * @param  string  $msg
     * @param  int     $priority One of the Propel::LOG_* logging levels
     * @return boolean
     */
    protected function log($msg, $priority = Propel::LOG_INFO)
    {
        return Propel::log(get_class($this) . ': ' . $msg, $priority);
    }

    /**
     * Populate the current object from a string, using a given parser format
     * <code>
     * $book = new Book();
     * $book->importFrom('JSON', '{"Id":9012,"Title":"Don Juan","ISBN":"0140422161","Price":12.99,"PublisherId":1234,"AuthorId":5678}');
     * </code>
     *
     * @param mixed $parser A AbstractParser instance,
     *                       or a format name ('XML', 'YAML', 'JSON', 'CSV')
     * @param string $data The source data to import from
     *
     * @return AmpSellerOrderVersion The current object, for fluid interface
     */
    public function importFrom($parser, $data)
    {
        if (!$parser instanceof AbstractParser) {
            $parser = AbstractParser::getParser($parser);
        }

        $this->fromArray($parser->toArray($data), TableMap::TYPE_PHPNAME);

        return $this;
    }

    /**
     * Export the current object properties to a string, using a given parser format
     * <code>
     * $book = BookQuery::create()->findPk(9012);
     * echo $book->exportTo('JSON');
     *  => {"Id":9012,"Title":"Don Juan","ISBN":"0140422161","Price":12.99,"PublisherId":1234,"AuthorId":5678}');
     * </code>
     *
     * @param  mixed   $parser                 A AbstractParser instance, or a format name ('XML', 'YAML', 'JSON', 'CSV')
     * @param  boolean $includeLazyLoadColumns (optional) Whether to include lazy load(ed) columns. Defaults to TRUE.
     * @return string  The exported data
     */
    public function exportTo($parser, $includeLazyLoadColumns = true)
    {
        if (!$parser instanceof AbstractParser) {
            $parser = AbstractParser::getParser($parser);
        }

        return $parser->fromArray($this->toArray(TableMap::TYPE_PHPNAME, $includeLazyLoadColumns, array(), true));
    }

    /**
     * Clean up internal collections prior to serializing
     * Avoids recursive loops that turn into segmentation faults when serializing
     */
    public function __sleep()
    {
        $this->clearAllReferences();

        return array_keys(get_object_vars($this));
    }

    /**
     * Get the [id] column value.
     *
     * @return   int
     */
    public function getId()
    {

        return $this->id;
    }

    /**
     * Get the [order_id] column value.
     *
     * @return   int
     */
    public function getOrderId()
    {

        return $this->order_id;
    }

    /**
     * Get the [amp_seller_id] column value.
     *
     * @return   int
     */
    public function getAmpSellerId()
    {

        return $this->amp_seller_id;
    }

    /**
     * Get the [customer_id] column value.
     *
     * @return   int
     */
    public function getCustomerId()
    {

        return $this->customer_id;
    }

    /**
     * Get the [order_product_id] column value.
     * the order products form the order
     * @return   string
     */
    public function getOrderProductId()
    {

        return $this->order_product_id;
    }

    /**
     * Get the [amp_seller_order_counter] column value.
     *
     * @return   int
     */
    public function getAmpSellerOrderCounter()
    {

        return $this->amp_seller_order_counter;
    }

    /**
     * Get the [seller_order_ref] column value.
     * the seller order reference
     * @return   string
     */
    public function getSellerOrderRef()
    {

        return $this->seller_order_ref;
    }

    /**
     * Get the [discount] column value.
     *
     * @return   string
     */
    public function getDiscount()
    {

        return $this->discount;
    }

    /**
     * Get the [postage] column value.
     *
     * @return   string
     */
    public function getPostage()
    {

        return $this->postage;
    }

    /**
     * Get the [postage_tax] column value.
     *
     * @return   string
     */
    public function getPostageTax()
    {

        return $this->postage_tax;
    }

    /**
     * Get the [status_id] column value.
     *
     * @return   int
     */
    public function getStatusId()
    {

        return $this->status_id;
    }

    /**
     * Get the [optionally formatted] temporal [created_at] column value.
     *
     *
     * @param      string $format The date/time format string (either date()-style or strftime()-style).
     *                            If format is NULL, then the raw \DateTime object will be returned.
     *
     * @return mixed Formatted date/time value as string or \DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00 00:00:00
     *
     * @throws PropelException - if unable to parse/validate the date/time value.
     */
    public function getCreatedAt($format = NULL)
    {
        if ($format === null) {
            return $this->created_at;
        } else {
            return $this->created_at instanceof \DateTime ? $this->created_at->format($format) : null;
        }
    }

    /**
     * Get the [optionally formatted] temporal [updated_at] column value.
     *
     *
     * @param      string $format The date/time format string (either date()-style or strftime()-style).
     *                            If format is NULL, then the raw \DateTime object will be returned.
     *
     * @return mixed Formatted date/time value as string or \DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00 00:00:00
     *
     * @throws PropelException - if unable to parse/validate the date/time value.
     */
    public function getUpdatedAt($format = NULL)
    {
        if ($format === null) {
            return $this->updated_at;
        } else {
            return $this->updated_at instanceof \DateTime ? $this->updated_at->format($format) : null;
        }
    }

    /**
     * Get the [version] column value.
     *
     * @return   int
     */
    public function getVersion()
    {

        return $this->version;
    }

    /**
     * Get the [optionally formatted] temporal [version_created_at] column value.
     *
     *
     * @param      string $format The date/time format string (either date()-style or strftime()-style).
     *                            If format is NULL, then the raw \DateTime object will be returned.
     *
     * @return mixed Formatted date/time value as string or \DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00 00:00:00
     *
     * @throws PropelException - if unable to parse/validate the date/time value.
     */
    public function getVersionCreatedAt($format = NULL)
    {
        if ($format === null) {
            return $this->version_created_at;
        } else {
            return $this->version_created_at instanceof \DateTime ? $this->version_created_at->format($format) : null;
        }
    }

    /**
     * Get the [version_created_by] column value.
     *
     * @return   string
     */
    public function getVersionCreatedBy()
    {

        return $this->version_created_by;
    }

    /**
     * Get the [customer_id_version] column value.
     *
     * @return   int
     */
    public function getCustomerIdVersion()
    {

        return $this->customer_id_version;
    }

    /**
     * Get the [amp_seller_id_version] column value.
     *
     * @return   int
     */
    public function getAmpSellerIdVersion()
    {

        return $this->amp_seller_id_version;
    }

    /**
     * Get the [order_id_version] column value.
     *
     * @return   int
     */
    public function getOrderIdVersion()
    {

        return $this->order_id_version;
    }

    /**
     * Get the [amp_seller_order_delivery_reference_ids] column value.
     *
     * @return   array
     */
    public function getAmpSellerOrderDeliveryReferenceIds()
    {
        if (null === $this->amp_seller_order_delivery_reference_ids_unserialized) {
            $this->amp_seller_order_delivery_reference_ids_unserialized = array();
        }
        if (!$this->amp_seller_order_delivery_reference_ids_unserialized && null !== $this->amp_seller_order_delivery_reference_ids) {
            $amp_seller_order_delivery_reference_ids_unserialized = substr($this->amp_seller_order_delivery_reference_ids, 2, -2);
            $this->amp_seller_order_delivery_reference_ids_unserialized = $amp_seller_order_delivery_reference_ids_unserialized ? explode(' | ', $amp_seller_order_delivery_reference_ids_unserialized) : array();
        }

        return $this->amp_seller_order_delivery_reference_ids_unserialized;
    }

    /**
     * Test the presence of a value in the [amp_seller_order_delivery_reference_ids] array column value.
     * @param      mixed $value
     *
     * @return boolean
     */
    public function hasAmpSellerOrderDeliveryReferenceId($value)
    {
        return in_array($value, $this->getAmpSellerOrderDeliveryReferenceIds());
    } // hasAmpSellerOrderDeliveryReferenceId()

    /**
     * Get the [amp_seller_order_delivery_reference_versions] column value.
     *
     * @return   array
     */
    public function getAmpSellerOrderDeliveryReferenceVersions()
    {
        if (null === $this->amp_seller_order_delivery_reference_versions_unserialized) {
            $this->amp_seller_order_delivery_reference_versions_unserialized = array();
        }
        if (!$this->amp_seller_order_delivery_reference_versions_unserialized && null !== $this->amp_seller_order_delivery_reference_versions) {
            $amp_seller_order_delivery_reference_versions_unserialized = substr($this->amp_seller_order_delivery_reference_versions, 2, -2);
            $this->amp_seller_order_delivery_reference_versions_unserialized = $amp_seller_order_delivery_reference_versions_unserialized ? explode(' | ', $amp_seller_order_delivery_reference_versions_unserialized) : array();
        }

        return $this->amp_seller_order_delivery_reference_versions_unserialized;
    }

    /**
     * Test the presence of a value in the [amp_seller_order_delivery_reference_versions] array column value.
     * @param      mixed $value
     *
     * @return boolean
     */
    public function hasAmpSellerOrderDeliveryReferenceVersion($value)
    {
        return in_array($value, $this->getAmpSellerOrderDeliveryReferenceVersions());
    } // hasAmpSellerOrderDeliveryReferenceVersion()

    /**
     * Set the value of [id] column.
     *
     * @param      int $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setId($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->id !== $v) {
            $this->id = $v;
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::ID] = true;
        }

        if ($this->aAmpSellerOrder !== null && $this->aAmpSellerOrder->getId() !== $v) {
            $this->aAmpSellerOrder = null;
        }


        return $this;
    } // setId()

    /**
     * Set the value of [order_id] column.
     *
     * @param      int $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setOrderId($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->order_id !== $v) {
            $this->order_id = $v;
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::ORDER_ID] = true;
        }


        return $this;
    } // setOrderId()

    /**
     * Set the value of [amp_seller_id] column.
     *
     * @param      int $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setAmpSellerId($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->amp_seller_id !== $v) {
            $this->amp_seller_id = $v;
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::AMP_SELLER_ID] = true;
        }


        return $this;
    } // setAmpSellerId()

    /**
     * Set the value of [customer_id] column.
     *
     * @param      int $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setCustomerId($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->customer_id !== $v) {
            $this->customer_id = $v;
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::CUSTOMER_ID] = true;
        }


        return $this;
    } // setCustomerId()

    /**
     * Set the value of [order_product_id] column.
     * the order products form the order
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setOrderProductId($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->order_product_id !== $v) {
            $this->order_product_id = $v;
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::ORDER_PRODUCT_ID] = true;
        }


        return $this;
    } // setOrderProductId()

    /**
     * Set the value of [amp_seller_order_counter] column.
     *
     * @param      int $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setAmpSellerOrderCounter($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->amp_seller_order_counter !== $v) {
            $this->amp_seller_order_counter = $v;
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_COUNTER] = true;
        }


        return $this;
    } // setAmpSellerOrderCounter()

    /**
     * Set the value of [seller_order_ref] column.
     * the seller order reference
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setSellerOrderRef($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->seller_order_ref !== $v) {
            $this->seller_order_ref = $v;
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::SELLER_ORDER_REF] = true;
        }


        return $this;
    } // setSellerOrderRef()

    /**
     * Set the value of [discount] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setDiscount($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->discount !== $v) {
            $this->discount = $v;
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::DISCOUNT] = true;
        }


        return $this;
    } // setDiscount()

    /**
     * Set the value of [postage] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setPostage($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->postage !== $v) {
            $this->postage = $v;
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::POSTAGE] = true;
        }


        return $this;
    } // setPostage()

    /**
     * Set the value of [postage_tax] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setPostageTax($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->postage_tax !== $v) {
            $this->postage_tax = $v;
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::POSTAGE_TAX] = true;
        }


        return $this;
    } // setPostageTax()

    /**
     * Set the value of [status_id] column.
     *
     * @param      int $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setStatusId($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->status_id !== $v) {
            $this->status_id = $v;
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::STATUS_ID] = true;
        }


        return $this;
    } // setStatusId()

    /**
     * Sets the value of [created_at] column to a normalized version of the date/time value specified.
     *
     * @param      mixed $v string, integer (timestamp), or \DateTime value.
     *               Empty strings are treated as NULL.
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setCreatedAt($v)
    {
        $dt = PropelDateTime::newInstance($v, null, '\DateTime');
        if ($this->created_at !== null || $dt !== null) {
            if ($dt !== $this->created_at) {
                $this->created_at = $dt;
                $this->modifiedColumns[AmpSellerOrderVersionTableMap::CREATED_AT] = true;
            }
        } // if either are not null


        return $this;
    } // setCreatedAt()

    /**
     * Sets the value of [updated_at] column to a normalized version of the date/time value specified.
     *
     * @param      mixed $v string, integer (timestamp), or \DateTime value.
     *               Empty strings are treated as NULL.
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setUpdatedAt($v)
    {
        $dt = PropelDateTime::newInstance($v, null, '\DateTime');
        if ($this->updated_at !== null || $dt !== null) {
            if ($dt !== $this->updated_at) {
                $this->updated_at = $dt;
                $this->modifiedColumns[AmpSellerOrderVersionTableMap::UPDATED_AT] = true;
            }
        } // if either are not null


        return $this;
    } // setUpdatedAt()

    /**
     * Set the value of [version] column.
     *
     * @param      int $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setVersion($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->version !== $v) {
            $this->version = $v;
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::VERSION] = true;
        }


        return $this;
    } // setVersion()

    /**
     * Sets the value of [version_created_at] column to a normalized version of the date/time value specified.
     *
     * @param      mixed $v string, integer (timestamp), or \DateTime value.
     *               Empty strings are treated as NULL.
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setVersionCreatedAt($v)
    {
        $dt = PropelDateTime::newInstance($v, null, '\DateTime');
        if ($this->version_created_at !== null || $dt !== null) {
            if ($dt !== $this->version_created_at) {
                $this->version_created_at = $dt;
                $this->modifiedColumns[AmpSellerOrderVersionTableMap::VERSION_CREATED_AT] = true;
            }
        } // if either are not null


        return $this;
    } // setVersionCreatedAt()

    /**
     * Set the value of [version_created_by] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setVersionCreatedBy($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->version_created_by !== $v) {
            $this->version_created_by = $v;
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::VERSION_CREATED_BY] = true;
        }


        return $this;
    } // setVersionCreatedBy()

    /**
     * Set the value of [customer_id_version] column.
     *
     * @param      int $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setCustomerIdVersion($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->customer_id_version !== $v) {
            $this->customer_id_version = $v;
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::CUSTOMER_ID_VERSION] = true;
        }


        return $this;
    } // setCustomerIdVersion()

    /**
     * Set the value of [amp_seller_id_version] column.
     *
     * @param      int $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setAmpSellerIdVersion($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->amp_seller_id_version !== $v) {
            $this->amp_seller_id_version = $v;
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::AMP_SELLER_ID_VERSION] = true;
        }


        return $this;
    } // setAmpSellerIdVersion()

    /**
     * Set the value of [order_id_version] column.
     *
     * @param      int $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setOrderIdVersion($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->order_id_version !== $v) {
            $this->order_id_version = $v;
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::ORDER_ID_VERSION] = true;
        }


        return $this;
    } // setOrderIdVersion()

    /**
     * Set the value of [amp_seller_order_delivery_reference_ids] column.
     *
     * @param      array $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setAmpSellerOrderDeliveryReferenceIds($v)
    {
        if ($this->amp_seller_order_delivery_reference_ids_unserialized !== $v) {
            $this->amp_seller_order_delivery_reference_ids_unserialized = $v;
            $this->amp_seller_order_delivery_reference_ids = '| ' . implode(' | ', $v) . ' |';
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_DELIVERY_REFERENCE_IDS] = true;
        }


        return $this;
    } // setAmpSellerOrderDeliveryReferenceIds()

    /**
     * Adds a value to the [amp_seller_order_delivery_reference_ids] array column value.
     * @param      mixed $value
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function addAmpSellerOrderDeliveryReferenceId($value)
    {
        $currentArray = $this->getAmpSellerOrderDeliveryReferenceIds();
        $currentArray []= $value;
        $this->setAmpSellerOrderDeliveryReferenceIds($currentArray);

        return $this;
    } // addAmpSellerOrderDeliveryReferenceId()

    /**
     * Removes a value from the [amp_seller_order_delivery_reference_ids] array column value.
     * @param      mixed $value
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function removeAmpSellerOrderDeliveryReferenceId($value)
    {
        $targetArray = array();
        foreach ($this->getAmpSellerOrderDeliveryReferenceIds() as $element) {
            if ($element != $value) {
                $targetArray []= $element;
            }
        }
        $this->setAmpSellerOrderDeliveryReferenceIds($targetArray);

        return $this;
    } // removeAmpSellerOrderDeliveryReferenceId()

    /**
     * Set the value of [amp_seller_order_delivery_reference_versions] column.
     *
     * @param      array $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function setAmpSellerOrderDeliveryReferenceVersions($v)
    {
        if ($this->amp_seller_order_delivery_reference_versions_unserialized !== $v) {
            $this->amp_seller_order_delivery_reference_versions_unserialized = $v;
            $this->amp_seller_order_delivery_reference_versions = '| ' . implode(' | ', $v) . ' |';
            $this->modifiedColumns[AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_DELIVERY_REFERENCE_VERSIONS] = true;
        }


        return $this;
    } // setAmpSellerOrderDeliveryReferenceVersions()

    /**
     * Adds a value to the [amp_seller_order_delivery_reference_versions] array column value.
     * @param      mixed $value
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function addAmpSellerOrderDeliveryReferenceVersion($value)
    {
        $currentArray = $this->getAmpSellerOrderDeliveryReferenceVersions();
        $currentArray []= $value;
        $this->setAmpSellerOrderDeliveryReferenceVersions($currentArray);

        return $this;
    } // addAmpSellerOrderDeliveryReferenceVersion()

    /**
     * Removes a value from the [amp_seller_order_delivery_reference_versions] array column value.
     * @param      mixed $value
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     */
    public function removeAmpSellerOrderDeliveryReferenceVersion($value)
    {
        $targetArray = array();
        foreach ($this->getAmpSellerOrderDeliveryReferenceVersions() as $element) {
            if ($element != $value) {
                $targetArray []= $element;
            }
        }
        $this->setAmpSellerOrderDeliveryReferenceVersions($targetArray);

        return $this;
    } // removeAmpSellerOrderDeliveryReferenceVersion()

    /**
     * Indicates whether the columns in this object are only set to default values.
     *
     * This method can be used in conjunction with isModified() to indicate whether an object is both
     * modified _and_ has some values set which are non-default.
     *
     * @return boolean Whether the columns in this object are only been set with default values.
     */
    public function hasOnlyDefaultValues()
    {
            if ($this->discount !== '0.000000') {
                return false;
            }

            if ($this->postage !== '0.000000') {
                return false;
            }

            if ($this->postage_tax !== '0.000000') {
                return false;
            }

            if ($this->version !== 0) {
                return false;
            }

            if ($this->customer_id_version !== 0) {
                return false;
            }

            if ($this->amp_seller_id_version !== 0) {
                return false;
            }

            if ($this->order_id_version !== 0) {
                return false;
            }

        // otherwise, everything was equal, so return TRUE
        return true;
    } // hasOnlyDefaultValues()

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (0-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param array   $row       The row returned by DataFetcher->fetch().
     * @param int     $startcol  0-based offset column which indicates which restultset column to start with.
     * @param boolean $rehydrate Whether this object is being re-hydrated from the database.
     * @param string  $indexType The index type of $row. Mostly DataFetcher->getIndexType().
                                  One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                            TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *
     * @return int             next starting column
     * @throws PropelException - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate($row, $startcol = 0, $rehydrate = false, $indexType = TableMap::TYPE_NUM)
    {
        try {


            $col = $row[TableMap::TYPE_NUM == $indexType ? 0 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)];
            $this->id = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 1 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('OrderId', TableMap::TYPE_PHPNAME, $indexType)];
            $this->order_id = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 2 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('AmpSellerId', TableMap::TYPE_PHPNAME, $indexType)];
            $this->amp_seller_id = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 3 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('CustomerId', TableMap::TYPE_PHPNAME, $indexType)];
            $this->customer_id = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 4 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('OrderProductId', TableMap::TYPE_PHPNAME, $indexType)];
            $this->order_product_id = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 5 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('AmpSellerOrderCounter', TableMap::TYPE_PHPNAME, $indexType)];
            $this->amp_seller_order_counter = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 6 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('SellerOrderRef', TableMap::TYPE_PHPNAME, $indexType)];
            $this->seller_order_ref = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 7 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('Discount', TableMap::TYPE_PHPNAME, $indexType)];
            $this->discount = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 8 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('Postage', TableMap::TYPE_PHPNAME, $indexType)];
            $this->postage = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 9 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('PostageTax', TableMap::TYPE_PHPNAME, $indexType)];
            $this->postage_tax = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 10 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('StatusId', TableMap::TYPE_PHPNAME, $indexType)];
            $this->status_id = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 11 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('CreatedAt', TableMap::TYPE_PHPNAME, $indexType)];
            if ($col === '0000-00-00 00:00:00') {
                $col = null;
            }
            $this->created_at = (null !== $col) ? PropelDateTime::newInstance($col, null, '\DateTime') : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 12 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('UpdatedAt', TableMap::TYPE_PHPNAME, $indexType)];
            if ($col === '0000-00-00 00:00:00') {
                $col = null;
            }
            $this->updated_at = (null !== $col) ? PropelDateTime::newInstance($col, null, '\DateTime') : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 13 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('Version', TableMap::TYPE_PHPNAME, $indexType)];
            $this->version = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 14 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('VersionCreatedAt', TableMap::TYPE_PHPNAME, $indexType)];
            if ($col === '0000-00-00 00:00:00') {
                $col = null;
            }
            $this->version_created_at = (null !== $col) ? PropelDateTime::newInstance($col, null, '\DateTime') : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 15 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('VersionCreatedBy', TableMap::TYPE_PHPNAME, $indexType)];
            $this->version_created_by = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 16 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('CustomerIdVersion', TableMap::TYPE_PHPNAME, $indexType)];
            $this->customer_id_version = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 17 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('AmpSellerIdVersion', TableMap::TYPE_PHPNAME, $indexType)];
            $this->amp_seller_id_version = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 18 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('OrderIdVersion', TableMap::TYPE_PHPNAME, $indexType)];
            $this->order_id_version = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 19 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('AmpSellerOrderDeliveryReferenceIds', TableMap::TYPE_PHPNAME, $indexType)];
            $this->amp_seller_order_delivery_reference_ids = $col;
            $this->amp_seller_order_delivery_reference_ids_unserialized = null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 20 + $startcol : AmpSellerOrderVersionTableMap::translateFieldName('AmpSellerOrderDeliveryReferenceVersions', TableMap::TYPE_PHPNAME, $indexType)];
            $this->amp_seller_order_delivery_reference_versions = $col;
            $this->amp_seller_order_delivery_reference_versions_unserialized = null;
            $this->resetModified();

            $this->setNew(false);

            if ($rehydrate) {
                $this->ensureConsistency();
            }

            return $startcol + 21; // 21 = AmpSellerOrderVersionTableMap::NUM_HYDRATE_COLUMNS.

        } catch (Exception $e) {
            throw new PropelException("Error populating \ArtabanMarketplace\Model\AmpSellerOrderVersion object", 0, $e);
        }
    }

    /**
     * Checks and repairs the internal consistency of the object.
     *
     * This method is executed after an already-instantiated object is re-hydrated
     * from the database.  It exists to check any foreign keys to make sure that
     * the objects related to the current object are correct based on foreign key.
     *
     * You can override this method in the stub class, but you should always invoke
     * the base method from the overridden method (i.e. parent::ensureConsistency()),
     * in case your model changes.
     *
     * @throws PropelException
     */
    public function ensureConsistency()
    {
        if ($this->aAmpSellerOrder !== null && $this->id !== $this->aAmpSellerOrder->getId()) {
            $this->aAmpSellerOrder = null;
        }
    } // ensureConsistency

    /**
     * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
     *
     * This will only work if the object has been saved and has a valid primary key set.
     *
     * @param      boolean $deep (optional) Whether to also de-associated any related objects.
     * @param      ConnectionInterface $con (optional) The ConnectionInterface connection to use.
     * @return void
     * @throws PropelException - if this object is deleted, unsaved or doesn't have pk match in db
     */
    public function reload($deep = false, ConnectionInterface $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("Cannot reload a deleted object.");
        }

        if ($this->isNew()) {
            throw new PropelException("Cannot reload an unsaved object.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getReadConnection(AmpSellerOrderVersionTableMap::DATABASE_NAME);
        }

        // We don't need to alter the object instance pool; we're just modifying this instance
        // already in the pool.

        $dataFetcher = ChildAmpSellerOrderVersionQuery::create(null, $this->buildPkeyCriteria())->setFormatter(ModelCriteria::FORMAT_STATEMENT)->find($con);
        $row = $dataFetcher->fetch();
        $dataFetcher->close();
        if (!$row) {
            throw new PropelException('Cannot find matching row in the database to reload object values.');
        }
        $this->hydrate($row, 0, true, $dataFetcher->getIndexType()); // rehydrate

        if ($deep) {  // also de-associate any related objects?

            $this->aAmpSellerOrder = null;
        } // if (deep)
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param      ConnectionInterface $con
     * @return void
     * @throws PropelException
     * @see AmpSellerOrderVersion::setDeleted()
     * @see AmpSellerOrderVersion::isDeleted()
     */
    public function delete(ConnectionInterface $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerOrderVersionTableMap::DATABASE_NAME);
        }

        $con->beginTransaction();
        try {
            $deleteQuery = ChildAmpSellerOrderVersionQuery::create()
                ->filterByPrimaryKey($this->getPrimaryKey());
            $ret = $this->preDelete($con);
            if ($ret) {
                $deleteQuery->delete($con);
                $this->postDelete($con);
                $con->commit();
                $this->setDeleted(true);
            } else {
                $con->commit();
            }
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Persists this object to the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All modified related objects will also be persisted in the doSave()
     * method.  This method wraps all precipitate database operations in a
     * single transaction.
     *
     * @param      ConnectionInterface $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see doSave()
     */
    public function save(ConnectionInterface $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerOrderVersionTableMap::DATABASE_NAME);
        }

        $con->beginTransaction();
        $isInsert = $this->isNew();
        try {
            $ret = $this->preSave($con);
            if ($isInsert) {
                $ret = $ret && $this->preInsert($con);
            } else {
                $ret = $ret && $this->preUpdate($con);
            }
            if ($ret) {
                $affectedRows = $this->doSave($con);
                if ($isInsert) {
                    $this->postInsert($con);
                } else {
                    $this->postUpdate($con);
                }
                $this->postSave($con);
                AmpSellerOrderVersionTableMap::addInstanceToPool($this);
            } else {
                $affectedRows = 0;
            }
            $con->commit();

            return $affectedRows;
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Performs the work of inserting or updating the row in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param      ConnectionInterface $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see save()
     */
    protected function doSave(ConnectionInterface $con)
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            // We call the save method on the following object(s) if they
            // were passed to this object by their corresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.

            if ($this->aAmpSellerOrder !== null) {
                if ($this->aAmpSellerOrder->isModified() || $this->aAmpSellerOrder->isNew()) {
                    $affectedRows += $this->aAmpSellerOrder->save($con);
                }
                $this->setAmpSellerOrder($this->aAmpSellerOrder);
            }

            if ($this->isNew() || $this->isModified()) {
                // persist changes
                if ($this->isNew()) {
                    $this->doInsert($con);
                } else {
                    $this->doUpdate($con);
                }
                $affectedRows += 1;
                $this->resetModified();
            }

            $this->alreadyInSave = false;

        }

        return $affectedRows;
    } // doSave()

    /**
     * Insert the row in the database.
     *
     * @param      ConnectionInterface $con
     *
     * @throws PropelException
     * @see doSave()
     */
    protected function doInsert(ConnectionInterface $con)
    {
        $modifiedColumns = array();
        $index = 0;


         // check the columns in natural order for more readable SQL queries
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::ID)) {
            $modifiedColumns[':p' . $index++]  = 'ID';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::ORDER_ID)) {
            $modifiedColumns[':p' . $index++]  = 'ORDER_ID';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::AMP_SELLER_ID)) {
            $modifiedColumns[':p' . $index++]  = 'AMP_SELLER_ID';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::CUSTOMER_ID)) {
            $modifiedColumns[':p' . $index++]  = 'CUSTOMER_ID';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::ORDER_PRODUCT_ID)) {
            $modifiedColumns[':p' . $index++]  = 'ORDER_PRODUCT_ID';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_COUNTER)) {
            $modifiedColumns[':p' . $index++]  = 'AMP_SELLER_ORDER_COUNTER';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::SELLER_ORDER_REF)) {
            $modifiedColumns[':p' . $index++]  = 'SELLER_ORDER_REF';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::DISCOUNT)) {
            $modifiedColumns[':p' . $index++]  = 'DISCOUNT';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::POSTAGE)) {
            $modifiedColumns[':p' . $index++]  = 'POSTAGE';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::POSTAGE_TAX)) {
            $modifiedColumns[':p' . $index++]  = 'POSTAGE_TAX';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::STATUS_ID)) {
            $modifiedColumns[':p' . $index++]  = 'STATUS_ID';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::CREATED_AT)) {
            $modifiedColumns[':p' . $index++]  = 'CREATED_AT';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::UPDATED_AT)) {
            $modifiedColumns[':p' . $index++]  = 'UPDATED_AT';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::VERSION)) {
            $modifiedColumns[':p' . $index++]  = 'VERSION';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::VERSION_CREATED_AT)) {
            $modifiedColumns[':p' . $index++]  = 'VERSION_CREATED_AT';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::VERSION_CREATED_BY)) {
            $modifiedColumns[':p' . $index++]  = 'VERSION_CREATED_BY';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::CUSTOMER_ID_VERSION)) {
            $modifiedColumns[':p' . $index++]  = 'CUSTOMER_ID_VERSION';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::AMP_SELLER_ID_VERSION)) {
            $modifiedColumns[':p' . $index++]  = 'AMP_SELLER_ID_VERSION';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::ORDER_ID_VERSION)) {
            $modifiedColumns[':p' . $index++]  = 'ORDER_ID_VERSION';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_DELIVERY_REFERENCE_IDS)) {
            $modifiedColumns[':p' . $index++]  = 'AMP_SELLER_ORDER_DELIVERY_REFERENCE_IDS';
        }
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_DELIVERY_REFERENCE_VERSIONS)) {
            $modifiedColumns[':p' . $index++]  = 'AMP_SELLER_ORDER_DELIVERY_REFERENCE_VERSIONS';
        }

        $sql = sprintf(
            'INSERT INTO amp_seller_order_version (%s) VALUES (%s)',
            implode(', ', $modifiedColumns),
            implode(', ', array_keys($modifiedColumns))
        );

        try {
            $stmt = $con->prepare($sql);
            foreach ($modifiedColumns as $identifier => $columnName) {
                switch ($columnName) {
                    case 'ID':
                        $stmt->bindValue($identifier, $this->id, PDO::PARAM_INT);
                        break;
                    case 'ORDER_ID':
                        $stmt->bindValue($identifier, $this->order_id, PDO::PARAM_INT);
                        break;
                    case 'AMP_SELLER_ID':
                        $stmt->bindValue($identifier, $this->amp_seller_id, PDO::PARAM_INT);
                        break;
                    case 'CUSTOMER_ID':
                        $stmt->bindValue($identifier, $this->customer_id, PDO::PARAM_INT);
                        break;
                    case 'ORDER_PRODUCT_ID':
                        $stmt->bindValue($identifier, $this->order_product_id, PDO::PARAM_STR);
                        break;
                    case 'AMP_SELLER_ORDER_COUNTER':
                        $stmt->bindValue($identifier, $this->amp_seller_order_counter, PDO::PARAM_INT);
                        break;
                    case 'SELLER_ORDER_REF':
                        $stmt->bindValue($identifier, $this->seller_order_ref, PDO::PARAM_STR);
                        break;
                    case 'DISCOUNT':
                        $stmt->bindValue($identifier, $this->discount, PDO::PARAM_STR);
                        break;
                    case 'POSTAGE':
                        $stmt->bindValue($identifier, $this->postage, PDO::PARAM_STR);
                        break;
                    case 'POSTAGE_TAX':
                        $stmt->bindValue($identifier, $this->postage_tax, PDO::PARAM_STR);
                        break;
                    case 'STATUS_ID':
                        $stmt->bindValue($identifier, $this->status_id, PDO::PARAM_INT);
                        break;
                    case 'CREATED_AT':
                        $stmt->bindValue($identifier, $this->created_at ? $this->created_at->format("Y-m-d H:i:s") : null, PDO::PARAM_STR);
                        break;
                    case 'UPDATED_AT':
                        $stmt->bindValue($identifier, $this->updated_at ? $this->updated_at->format("Y-m-d H:i:s") : null, PDO::PARAM_STR);
                        break;
                    case 'VERSION':
                        $stmt->bindValue($identifier, $this->version, PDO::PARAM_INT);
                        break;
                    case 'VERSION_CREATED_AT':
                        $stmt->bindValue($identifier, $this->version_created_at ? $this->version_created_at->format("Y-m-d H:i:s") : null, PDO::PARAM_STR);
                        break;
                    case 'VERSION_CREATED_BY':
                        $stmt->bindValue($identifier, $this->version_created_by, PDO::PARAM_STR);
                        break;
                    case 'CUSTOMER_ID_VERSION':
                        $stmt->bindValue($identifier, $this->customer_id_version, PDO::PARAM_INT);
                        break;
                    case 'AMP_SELLER_ID_VERSION':
                        $stmt->bindValue($identifier, $this->amp_seller_id_version, PDO::PARAM_INT);
                        break;
                    case 'ORDER_ID_VERSION':
                        $stmt->bindValue($identifier, $this->order_id_version, PDO::PARAM_INT);
                        break;
                    case 'AMP_SELLER_ORDER_DELIVERY_REFERENCE_IDS':
                        $stmt->bindValue($identifier, $this->amp_seller_order_delivery_reference_ids, PDO::PARAM_STR);
                        break;
                    case 'AMP_SELLER_ORDER_DELIVERY_REFERENCE_VERSIONS':
                        $stmt->bindValue($identifier, $this->amp_seller_order_delivery_reference_versions, PDO::PARAM_STR);
                        break;
                }
            }
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute INSERT statement [%s]', $sql), 0, $e);
        }

        $this->setNew(false);
    }

    /**
     * Update the row in the database.
     *
     * @param      ConnectionInterface $con
     *
     * @return Integer Number of updated rows
     * @see doSave()
     */
    protected function doUpdate(ConnectionInterface $con)
    {
        $selectCriteria = $this->buildPkeyCriteria();
        $valuesCriteria = $this->buildCriteria();

        return $selectCriteria->doUpdate($valuesCriteria, $con);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param      string $name name
     * @param      string $type The type of fieldname the $name is of:
     *                     one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                     TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                     Defaults to TableMap::TYPE_PHPNAME.
     * @return mixed Value of field.
     */
    public function getByName($name, $type = TableMap::TYPE_PHPNAME)
    {
        $pos = AmpSellerOrderVersionTableMap::translateFieldName($name, $type, TableMap::TYPE_NUM);
        $field = $this->getByPosition($pos);

        return $field;
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param      int $pos position in xml schema
     * @return mixed Value of field at $pos
     */
    public function getByPosition($pos)
    {
        switch ($pos) {
            case 0:
                return $this->getId();
                break;
            case 1:
                return $this->getOrderId();
                break;
            case 2:
                return $this->getAmpSellerId();
                break;
            case 3:
                return $this->getCustomerId();
                break;
            case 4:
                return $this->getOrderProductId();
                break;
            case 5:
                return $this->getAmpSellerOrderCounter();
                break;
            case 6:
                return $this->getSellerOrderRef();
                break;
            case 7:
                return $this->getDiscount();
                break;
            case 8:
                return $this->getPostage();
                break;
            case 9:
                return $this->getPostageTax();
                break;
            case 10:
                return $this->getStatusId();
                break;
            case 11:
                return $this->getCreatedAt();
                break;
            case 12:
                return $this->getUpdatedAt();
                break;
            case 13:
                return $this->getVersion();
                break;
            case 14:
                return $this->getVersionCreatedAt();
                break;
            case 15:
                return $this->getVersionCreatedBy();
                break;
            case 16:
                return $this->getCustomerIdVersion();
                break;
            case 17:
                return $this->getAmpSellerIdVersion();
                break;
            case 18:
                return $this->getOrderIdVersion();
                break;
            case 19:
                return $this->getAmpSellerOrderDeliveryReferenceIds();
                break;
            case 20:
                return $this->getAmpSellerOrderDeliveryReferenceVersions();
                break;
            default:
                return null;
                break;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param     string  $keyType (optional) One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME,
     *                    TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                    Defaults to TableMap::TYPE_PHPNAME.
     * @param     boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns. Defaults to TRUE.
     * @param     array $alreadyDumpedObjects List of objects to skip to avoid recursion
     * @param     boolean $includeForeignObjects (optional) Whether to include hydrated related objects. Default to FALSE.
     *
     * @return array an associative array containing the field names (as keys) and field values
     */
    public function toArray($keyType = TableMap::TYPE_PHPNAME, $includeLazyLoadColumns = true, $alreadyDumpedObjects = array(), $includeForeignObjects = false)
    {
        if (isset($alreadyDumpedObjects['AmpSellerOrderVersion'][serialize($this->getPrimaryKey())])) {
            return '*RECURSION*';
        }
        $alreadyDumpedObjects['AmpSellerOrderVersion'][serialize($this->getPrimaryKey())] = true;
        $keys = AmpSellerOrderVersionTableMap::getFieldNames($keyType);
        $result = array(
            $keys[0] => $this->getId(),
            $keys[1] => $this->getOrderId(),
            $keys[2] => $this->getAmpSellerId(),
            $keys[3] => $this->getCustomerId(),
            $keys[4] => $this->getOrderProductId(),
            $keys[5] => $this->getAmpSellerOrderCounter(),
            $keys[6] => $this->getSellerOrderRef(),
            $keys[7] => $this->getDiscount(),
            $keys[8] => $this->getPostage(),
            $keys[9] => $this->getPostageTax(),
            $keys[10] => $this->getStatusId(),
            $keys[11] => $this->getCreatedAt(),
            $keys[12] => $this->getUpdatedAt(),
            $keys[13] => $this->getVersion(),
            $keys[14] => $this->getVersionCreatedAt(),
            $keys[15] => $this->getVersionCreatedBy(),
            $keys[16] => $this->getCustomerIdVersion(),
            $keys[17] => $this->getAmpSellerIdVersion(),
            $keys[18] => $this->getOrderIdVersion(),
            $keys[19] => $this->getAmpSellerOrderDeliveryReferenceIds(),
            $keys[20] => $this->getAmpSellerOrderDeliveryReferenceVersions(),
        );
        $virtualColumns = $this->virtualColumns;
        foreach ($virtualColumns as $key => $virtualColumn) {
            $result[$key] = $virtualColumn;
        }

        if ($includeForeignObjects) {
            if (null !== $this->aAmpSellerOrder) {
                $result['AmpSellerOrder'] = $this->aAmpSellerOrder->toArray($keyType, $includeLazyLoadColumns,  $alreadyDumpedObjects, true);
            }
        }

        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param      string $name
     * @param      mixed  $value field value
     * @param      string $type The type of fieldname the $name is of:
     *                     one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                     TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                     Defaults to TableMap::TYPE_PHPNAME.
     * @return void
     */
    public function setByName($name, $value, $type = TableMap::TYPE_PHPNAME)
    {
        $pos = AmpSellerOrderVersionTableMap::translateFieldName($name, $type, TableMap::TYPE_NUM);

        return $this->setByPosition($pos, $value);
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param      int $pos position in xml schema
     * @param      mixed $value field value
     * @return void
     */
    public function setByPosition($pos, $value)
    {
        switch ($pos) {
            case 0:
                $this->setId($value);
                break;
            case 1:
                $this->setOrderId($value);
                break;
            case 2:
                $this->setAmpSellerId($value);
                break;
            case 3:
                $this->setCustomerId($value);
                break;
            case 4:
                $this->setOrderProductId($value);
                break;
            case 5:
                $this->setAmpSellerOrderCounter($value);
                break;
            case 6:
                $this->setSellerOrderRef($value);
                break;
            case 7:
                $this->setDiscount($value);
                break;
            case 8:
                $this->setPostage($value);
                break;
            case 9:
                $this->setPostageTax($value);
                break;
            case 10:
                $this->setStatusId($value);
                break;
            case 11:
                $this->setCreatedAt($value);
                break;
            case 12:
                $this->setUpdatedAt($value);
                break;
            case 13:
                $this->setVersion($value);
                break;
            case 14:
                $this->setVersionCreatedAt($value);
                break;
            case 15:
                $this->setVersionCreatedBy($value);
                break;
            case 16:
                $this->setCustomerIdVersion($value);
                break;
            case 17:
                $this->setAmpSellerIdVersion($value);
                break;
            case 18:
                $this->setOrderIdVersion($value);
                break;
            case 19:
                if (!is_array($value)) {
                    $v = trim(substr($value, 2, -2));
                    $value = $v ? explode(' | ', $v) : array();
                }
                $this->setAmpSellerOrderDeliveryReferenceIds($value);
                break;
            case 20:
                if (!is_array($value)) {
                    $v = trim(substr($value, 2, -2));
                    $value = $v ? explode(' | ', $v) : array();
                }
                $this->setAmpSellerOrderDeliveryReferenceVersions($value);
                break;
        } // switch()
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME,
     * TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     * The default key type is the column's TableMap::TYPE_PHPNAME.
     *
     * @param      array  $arr     An array to populate the object from.
     * @param      string $keyType The type of keys the array uses.
     * @return void
     */
    public function fromArray($arr, $keyType = TableMap::TYPE_PHPNAME)
    {
        $keys = AmpSellerOrderVersionTableMap::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
        if (array_key_exists($keys[1], $arr)) $this->setOrderId($arr[$keys[1]]);
        if (array_key_exists($keys[2], $arr)) $this->setAmpSellerId($arr[$keys[2]]);
        if (array_key_exists($keys[3], $arr)) $this->setCustomerId($arr[$keys[3]]);
        if (array_key_exists($keys[4], $arr)) $this->setOrderProductId($arr[$keys[4]]);
        if (array_key_exists($keys[5], $arr)) $this->setAmpSellerOrderCounter($arr[$keys[5]]);
        if (array_key_exists($keys[6], $arr)) $this->setSellerOrderRef($arr[$keys[6]]);
        if (array_key_exists($keys[7], $arr)) $this->setDiscount($arr[$keys[7]]);
        if (array_key_exists($keys[8], $arr)) $this->setPostage($arr[$keys[8]]);
        if (array_key_exists($keys[9], $arr)) $this->setPostageTax($arr[$keys[9]]);
        if (array_key_exists($keys[10], $arr)) $this->setStatusId($arr[$keys[10]]);
        if (array_key_exists($keys[11], $arr)) $this->setCreatedAt($arr[$keys[11]]);
        if (array_key_exists($keys[12], $arr)) $this->setUpdatedAt($arr[$keys[12]]);
        if (array_key_exists($keys[13], $arr)) $this->setVersion($arr[$keys[13]]);
        if (array_key_exists($keys[14], $arr)) $this->setVersionCreatedAt($arr[$keys[14]]);
        if (array_key_exists($keys[15], $arr)) $this->setVersionCreatedBy($arr[$keys[15]]);
        if (array_key_exists($keys[16], $arr)) $this->setCustomerIdVersion($arr[$keys[16]]);
        if (array_key_exists($keys[17], $arr)) $this->setAmpSellerIdVersion($arr[$keys[17]]);
        if (array_key_exists($keys[18], $arr)) $this->setOrderIdVersion($arr[$keys[18]]);
        if (array_key_exists($keys[19], $arr)) $this->setAmpSellerOrderDeliveryReferenceIds($arr[$keys[19]]);
        if (array_key_exists($keys[20], $arr)) $this->setAmpSellerOrderDeliveryReferenceVersions($arr[$keys[20]]);
    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {
        $criteria = new Criteria(AmpSellerOrderVersionTableMap::DATABASE_NAME);

        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::ID)) $criteria->add(AmpSellerOrderVersionTableMap::ID, $this->id);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::ORDER_ID)) $criteria->add(AmpSellerOrderVersionTableMap::ORDER_ID, $this->order_id);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::AMP_SELLER_ID)) $criteria->add(AmpSellerOrderVersionTableMap::AMP_SELLER_ID, $this->amp_seller_id);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::CUSTOMER_ID)) $criteria->add(AmpSellerOrderVersionTableMap::CUSTOMER_ID, $this->customer_id);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::ORDER_PRODUCT_ID)) $criteria->add(AmpSellerOrderVersionTableMap::ORDER_PRODUCT_ID, $this->order_product_id);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_COUNTER)) $criteria->add(AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_COUNTER, $this->amp_seller_order_counter);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::SELLER_ORDER_REF)) $criteria->add(AmpSellerOrderVersionTableMap::SELLER_ORDER_REF, $this->seller_order_ref);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::DISCOUNT)) $criteria->add(AmpSellerOrderVersionTableMap::DISCOUNT, $this->discount);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::POSTAGE)) $criteria->add(AmpSellerOrderVersionTableMap::POSTAGE, $this->postage);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::POSTAGE_TAX)) $criteria->add(AmpSellerOrderVersionTableMap::POSTAGE_TAX, $this->postage_tax);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::STATUS_ID)) $criteria->add(AmpSellerOrderVersionTableMap::STATUS_ID, $this->status_id);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::CREATED_AT)) $criteria->add(AmpSellerOrderVersionTableMap::CREATED_AT, $this->created_at);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::UPDATED_AT)) $criteria->add(AmpSellerOrderVersionTableMap::UPDATED_AT, $this->updated_at);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::VERSION)) $criteria->add(AmpSellerOrderVersionTableMap::VERSION, $this->version);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::VERSION_CREATED_AT)) $criteria->add(AmpSellerOrderVersionTableMap::VERSION_CREATED_AT, $this->version_created_at);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::VERSION_CREATED_BY)) $criteria->add(AmpSellerOrderVersionTableMap::VERSION_CREATED_BY, $this->version_created_by);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::CUSTOMER_ID_VERSION)) $criteria->add(AmpSellerOrderVersionTableMap::CUSTOMER_ID_VERSION, $this->customer_id_version);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::AMP_SELLER_ID_VERSION)) $criteria->add(AmpSellerOrderVersionTableMap::AMP_SELLER_ID_VERSION, $this->amp_seller_id_version);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::ORDER_ID_VERSION)) $criteria->add(AmpSellerOrderVersionTableMap::ORDER_ID_VERSION, $this->order_id_version);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_DELIVERY_REFERENCE_IDS)) $criteria->add(AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_DELIVERY_REFERENCE_IDS, $this->amp_seller_order_delivery_reference_ids);
        if ($this->isColumnModified(AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_DELIVERY_REFERENCE_VERSIONS)) $criteria->add(AmpSellerOrderVersionTableMap::AMP_SELLER_ORDER_DELIVERY_REFERENCE_VERSIONS, $this->amp_seller_order_delivery_reference_versions);

        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     *
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {
        $criteria = new Criteria(AmpSellerOrderVersionTableMap::DATABASE_NAME);
        $criteria->add(AmpSellerOrderVersionTableMap::ID, $this->id);
        $criteria->add(AmpSellerOrderVersionTableMap::VERSION, $this->version);

        return $criteria;
    }

    /**
     * Returns the composite primary key for this object.
     * The array elements will be in same order as specified in XML.
     * @return array
     */
    public function getPrimaryKey()
    {
        $pks = array();
        $pks[0] = $this->getId();
        $pks[1] = $this->getVersion();

        return $pks;
    }

    /**
     * Set the [composite] primary key.
     *
     * @param      array $keys The elements of the composite key (order must match the order in XML file).
     * @return void
     */
    public function setPrimaryKey($keys)
    {
        $this->setId($keys[0]);
        $this->setVersion($keys[1]);
    }

    /**
     * Returns true if the primary key for this object is null.
     * @return boolean
     */
    public function isPrimaryKeyNull()
    {

        return (null === $this->getId()) && (null === $this->getVersion());
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param      object $copyObj An object of \ArtabanMarketplace\Model\AmpSellerOrderVersion (or compatible) type.
     * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @param      boolean $makeNew Whether to reset autoincrement PKs and make the object new.
     * @throws PropelException
     */
    public function copyInto($copyObj, $deepCopy = false, $makeNew = true)
    {
        $copyObj->setId($this->getId());
        $copyObj->setOrderId($this->getOrderId());
        $copyObj->setAmpSellerId($this->getAmpSellerId());
        $copyObj->setCustomerId($this->getCustomerId());
        $copyObj->setOrderProductId($this->getOrderProductId());
        $copyObj->setAmpSellerOrderCounter($this->getAmpSellerOrderCounter());
        $copyObj->setSellerOrderRef($this->getSellerOrderRef());
        $copyObj->setDiscount($this->getDiscount());
        $copyObj->setPostage($this->getPostage());
        $copyObj->setPostageTax($this->getPostageTax());
        $copyObj->setStatusId($this->getStatusId());
        $copyObj->setCreatedAt($this->getCreatedAt());
        $copyObj->setUpdatedAt($this->getUpdatedAt());
        $copyObj->setVersion($this->getVersion());
        $copyObj->setVersionCreatedAt($this->getVersionCreatedAt());
        $copyObj->setVersionCreatedBy($this->getVersionCreatedBy());
        $copyObj->setCustomerIdVersion($this->getCustomerIdVersion());
        $copyObj->setAmpSellerIdVersion($this->getAmpSellerIdVersion());
        $copyObj->setOrderIdVersion($this->getOrderIdVersion());
        $copyObj->setAmpSellerOrderDeliveryReferenceIds($this->getAmpSellerOrderDeliveryReferenceIds());
        $copyObj->setAmpSellerOrderDeliveryReferenceVersions($this->getAmpSellerOrderDeliveryReferenceVersions());
        if ($makeNew) {
            $copyObj->setNew(true);
        }
    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return                 \ArtabanMarketplace\Model\AmpSellerOrderVersion Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);

        return $copyObj;
    }

    /**
     * Declares an association between this object and a ChildAmpSellerOrder object.
     *
     * @param                  ChildAmpSellerOrder $v
     * @return                 \ArtabanMarketplace\Model\AmpSellerOrderVersion The current object (for fluent API support)
     * @throws PropelException
     */
    public function setAmpSellerOrder(ChildAmpSellerOrder $v = null)
    {
        if ($v === null) {
            $this->setId(NULL);
        } else {
            $this->setId($v->getId());
        }

        $this->aAmpSellerOrder = $v;

        // Add binding for other direction of this n:n relationship.
        // If this object has already been added to the ChildAmpSellerOrder object, it will not be re-added.
        if ($v !== null) {
            $v->addAmpSellerOrderVersion($this);
        }


        return $this;
    }


    /**
     * Get the associated ChildAmpSellerOrder object
     *
     * @param      ConnectionInterface $con Optional Connection object.
     * @return                 ChildAmpSellerOrder The associated ChildAmpSellerOrder object.
     * @throws PropelException
     */
    public function getAmpSellerOrder(ConnectionInterface $con = null)
    {
        if ($this->aAmpSellerOrder === null && ($this->id !== null)) {
            $this->aAmpSellerOrder = ChildAmpSellerOrderQuery::create()->findPk($this->id, $con);
            /* The following can be used additionally to
                guarantee the related object contains a reference
                to this object.  This level of coupling may, however, be
                undesirable since it could result in an only partially populated collection
                in the referenced object.
                $this->aAmpSellerOrder->addAmpSellerOrderVersions($this);
             */
        }

        return $this->aAmpSellerOrder;
    }

    /**
     * Clears the current object and sets all attributes to their default values
     */
    public function clear()
    {
        $this->id = null;
        $this->order_id = null;
        $this->amp_seller_id = null;
        $this->customer_id = null;
        $this->order_product_id = null;
        $this->amp_seller_order_counter = null;
        $this->seller_order_ref = null;
        $this->discount = null;
        $this->postage = null;
        $this->postage_tax = null;
        $this->status_id = null;
        $this->created_at = null;
        $this->updated_at = null;
        $this->version = null;
        $this->version_created_at = null;
        $this->version_created_by = null;
        $this->customer_id_version = null;
        $this->amp_seller_id_version = null;
        $this->order_id_version = null;
        $this->amp_seller_order_delivery_reference_ids = null;
        $this->amp_seller_order_delivery_reference_ids_unserialized = null;
        $this->amp_seller_order_delivery_reference_versions = null;
        $this->amp_seller_order_delivery_reference_versions_unserialized = null;
        $this->alreadyInSave = false;
        $this->clearAllReferences();
        $this->applyDefaultValues();
        $this->resetModified();
        $this->setNew(true);
        $this->setDeleted(false);
    }

    /**
     * Resets all references to other model objects or collections of model objects.
     *
     * This method is a user-space workaround for PHP's inability to garbage collect
     * objects with circular references (even in PHP 5.3). This is currently necessary
     * when using Propel in certain daemon or large-volume/high-memory operations.
     *
     * @param      boolean $deep Whether to also clear the references on all referrer objects.
     */
    public function clearAllReferences($deep = false)
    {
        if ($deep) {
        } // if ($deep)

        $this->aAmpSellerOrder = null;
    }

    /**
     * Return the string representation of this object
     *
     * @return string
     */
    public function __toString()
    {
        return (string) $this->exportTo(AmpSellerOrderVersionTableMap::DEFAULT_STRING_FORMAT);
    }

    /**
     * Code to be run before persisting the object
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preSave(ConnectionInterface $con = null)
    {
        return true;
    }

    /**
     * Code to be run after persisting the object
     * @param ConnectionInterface $con
     */
    public function postSave(ConnectionInterface $con = null)
    {

    }

    /**
     * Code to be run before inserting to database
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preInsert(ConnectionInterface $con = null)
    {
        return true;
    }

    /**
     * Code to be run after inserting to database
     * @param ConnectionInterface $con
     */
    public function postInsert(ConnectionInterface $con = null)
    {

    }

    /**
     * Code to be run before updating the object in database
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preUpdate(ConnectionInterface $con = null)
    {
        return true;
    }

    /**
     * Code to be run after updating the object in database
     * @param ConnectionInterface $con
     */
    public function postUpdate(ConnectionInterface $con = null)
    {

    }

    /**
     * Code to be run before deleting the object in database
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preDelete(ConnectionInterface $con = null)
    {
        return true;
    }

    /**
     * Code to be run after deleting the object in database
     * @param ConnectionInterface $con
     */
    public function postDelete(ConnectionInterface $con = null)
    {

    }


    /**
     * Derived method to catches calls to undefined methods.
     *
     * Provides magic import/export method support (fromXML()/toXML(), fromYAML()/toYAML(), etc.).
     * Allows to define default __call() behavior if you overwrite __call()
     *
     * @param string $name
     * @param mixed  $params
     *
     * @return array|string
     */
    public function __call($name, $params)
    {
        if (0 === strpos($name, 'get')) {
            $virtualColumn = substr($name, 3);
            if ($this->hasVirtualColumn($virtualColumn)) {
                return $this->getVirtualColumn($virtualColumn);
            }

            $virtualColumn = lcfirst($virtualColumn);
            if ($this->hasVirtualColumn($virtualColumn)) {
                return $this->getVirtualColumn($virtualColumn);
            }
        }

        if (0 === strpos($name, 'from')) {
            $format = substr($name, 4);

            return $this->importFrom($format, reset($params));
        }

        if (0 === strpos($name, 'to')) {
            $format = substr($name, 2);
            $includeLazyLoadColumns = isset($params[0]) ? $params[0] : true;

            return $this->exportTo($format, $includeLazyLoadColumns);
        }

        throw new BadMethodCallException(sprintf('Call to undefined method: %s.', $name));
    }

}
